package com.datacloudsec.scan.cache;

import com.datacloudsec.scan.common.Constant;
import com.datacloudsec.scan.entity.WebConfig;
import com.datacloudsec.utils.JsonUtil;
import com.fasterxml.jackson.databind.JavaType;
import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class WebProxyConfig {

   private List proxy;
   private Map webConfig;
   private static long lastMdfTime;
   private static File confFile = new File(Constant.WORK_DIR, "conf/proxy.json");
   private static WebProxyConfig instance;


   public static synchronized WebProxyConfig getInstance() throws Exception {
      if(instance == null) {
         instance = new WebProxyConfig();
      }

      if(confFile.lastModified() != lastMdfTime) {
         JavaType javaType = JsonUtil.MAPPER_ESCAPE_HTML.getTypeFactory().constructParametricType(ArrayList.class, new Class[]{WebConfig.class});
         instance.proxy = (List)JsonUtil.MAPPER_ESCAPE_HTML.readValue(confFile, javaType);
         instance.webConfig = new HashMap();
         Iterator var2 = instance.proxy.iterator();

         while(var2.hasNext()) {
            WebConfig wc = (WebConfig)var2.next();
            instance.webConfig.put(wc.getName(), wc);
         }

         lastMdfTime = confFile.lastModified();
      }

      return instance;
   }

   public static void main(String[] args) throws Exception {
      System.out.println(getInstance().getWebConfig());
   }

   public List getProxy() {
      return this.proxy;
   }

   public Map getWebConfig() {
      return this.webConfig;
   }
}
